#!/usr/bin/env python
# coding: utf-8

import sqlite3
import io
import os
import sys
from rdkit import Chem

targetSMILES = sys.argv[1]
#targetSMILES = "O=c1ccc(CCCc2ccccc2)cn1O"
threshold = float(sys.argv[2]) #convert argv to float

connection = sqlite3.connect("/Users/chrisswain/Projects/ChEMBL/chembldb.sqlite")
#using external SSD
#connection = sqlite3.connect("/Volumes/ExternaLSSD/Projects/ChEMBL/chembldb.sqlite")
cursor = connection.cursor()
connection.enable_load_extension(True)
connection.load_extension('chemicalite')
connection.enable_load_extension(False)

        
                   
                   
rs = connection.execute(
    "SELECT c.chembl_id, mol_to_smiles(c.molecule), " +
    "bfp_tanimoto(mol_morgan_bfp(c.molecule, 2, 1024), "
    "             mol_morgan_bfp(mol_from_smiles(?1), 2, 1024)) as t " +
    "FROM " +
    "chembl as c JOIN morgan_idx_chembl_molecule as idx USING(id) " +
    "WHERE " +
    "idx.id MATCH rdtree_tanimoto(mol_morgan_bfp(mol_from_smiles(?1), 2, 1024), ?2) " +
    "ORDER BY t DESC", (targetSMILES, threshold)).fetchall() 
    
count = len(rs)                

if not count:
	ReturnedData = ""
else:	
	ReturnedData = count


print(ReturnedData)


